using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Bootloader;

namespace AYUCR_Firmware_Updater
{
	/// <summary>
	/// Summary description for MainForm.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.LinkLabel hyperlinkLabel;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.TextBox FilenameText;
		private System.Windows.Forms.Button SearchButton;
		private System.Windows.Forms.ComboBox PortCombo;
		private System.Windows.Forms.ComboBox BaudRateCombo;
		private System.Windows.Forms.TextBox StatusText;
		private System.Windows.Forms.TextBox HexDumpText;
		private System.Windows.Forms.Button WriteButton;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.ProgressBar WriteProgress;

		/// <summary>
		/// Main Form Variables
		/// </summary>
		Firmware firmware;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			Version ver = new Version (Application.ProductVersion);
			this.Text += String.Format (" {0}.{1}", ver.Major, ver.Minor);

			PortCombo.SelectedItem = "COM1";
			BaudRateCombo.SelectedItem = "2400";
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.label1 = new System.Windows.Forms.Label();
			this.FilenameText = new System.Windows.Forms.TextBox();
			this.WriteProgress = new System.Windows.Forms.ProgressBar();
			this.hyperlinkLabel = new System.Windows.Forms.LinkLabel();
			this.label3 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.SearchButton = new System.Windows.Forms.Button();
			this.label5 = new System.Windows.Forms.Label();
			this.PortCombo = new System.Windows.Forms.ComboBox();
			this.BaudRateCombo = new System.Windows.Forms.ComboBox();
			this.StatusText = new System.Windows.Forms.TextBox();
			this.WriteButton = new System.Windows.Forms.Button();
			this.HexDumpText = new System.Windows.Forms.TextBox();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(24, 20);
			this.label1.TabIndex = 0;
			this.label1.Text = "File";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// FilenameText
			// 
			this.FilenameText.Location = new System.Drawing.Point(40, 16);
			this.FilenameText.Name = "FilenameText";
			this.FilenameText.Size = new System.Drawing.Size(192, 20);
			this.FilenameText.TabIndex = 1;
			this.FilenameText.Text = "";
			// 
			// WriteProgress
			// 
			this.WriteProgress.Location = new System.Drawing.Point(8, 264);
			this.WriteProgress.Name = "WriteProgress";
			this.WriteProgress.Size = new System.Drawing.Size(304, 23);
			this.WriteProgress.Step = 1;
			this.WriteProgress.TabIndex = 2;
			// 
			// hyperlinkLabel
			// 
			this.hyperlinkLabel.Location = new System.Drawing.Point(8, 304);
			this.hyperlinkLabel.Name = "hyperlinkLabel";
			this.hyperlinkLabel.Size = new System.Drawing.Size(128, 23);
			this.hyperlinkLabel.TabIndex = 5;
			this.hyperlinkLabel.TabStop = true;
			this.hyperlinkLabel.Text = "http://www.ayucr.com";
			this.hyperlinkLabel.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabel1_LinkClicked);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(192, 304);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(120, 16);
			this.label3.TabIndex = 6;
			this.label3.Text = " 2004 Robert F. Nee";
			// 
			// label4
			// 
			this.label4.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.label4.Location = new System.Drawing.Point(8, 296);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(304, 1);
			this.label4.TabIndex = 7;
			// 
			// SearchButton
			// 
			this.SearchButton.Location = new System.Drawing.Point(240, 15);
			this.SearchButton.Name = "SearchButton";
			this.SearchButton.Size = new System.Drawing.Size(72, 23);
			this.SearchButton.TabIndex = 8;
			this.SearchButton.Text = "&Search";
			this.SearchButton.Click += new System.EventHandler(this.Search_Click);
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(8, 56);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(32, 21);
			this.label5.TabIndex = 9;
			this.label5.Text = "Port";
			this.label5.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// PortCombo
			// 
			this.PortCombo.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.PortCombo.Items.AddRange(new object[] {
														   "COM1",
														   "COM2",
														   "COM3",
														   "COM4",
														   "COM5",
														   "COM6",
														   "COM7",
														   "COM8"});
			this.PortCombo.Location = new System.Drawing.Point(40, 56);
			this.PortCombo.Name = "PortCombo";
			this.PortCombo.Size = new System.Drawing.Size(72, 21);
			this.PortCombo.TabIndex = 10;
			this.PortCombo.SelectedIndexChanged += new System.EventHandler(this.comboBox1_SelectedIndexChanged);
			// 
			// BaudRateCombo
			// 
			this.BaudRateCombo.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.BaudRateCombo.Items.AddRange(new object[] {
															   "2400",
															   "4800",
															   "9600",
															   "19200"});
			this.BaudRateCombo.Location = new System.Drawing.Point(128, 56);
			this.BaudRateCombo.Name = "BaudRateCombo";
			this.BaudRateCombo.Size = new System.Drawing.Size(72, 21);
			this.BaudRateCombo.TabIndex = 11;
			// 
			// StatusText
			// 
			this.StatusText.Location = new System.Drawing.Point(8, 232);
			this.StatusText.Name = "StatusText";
			this.StatusText.ReadOnly = true;
			this.StatusText.Size = new System.Drawing.Size(304, 20);
			this.StatusText.TabIndex = 12;
			this.StatusText.TabStop = false;
			this.StatusText.Text = "";
			// 
			// WriteButton
			// 
			this.WriteButton.Enabled = false;
			this.WriteButton.Location = new System.Drawing.Point(240, 56);
			this.WriteButton.Name = "WriteButton";
			this.WriteButton.Size = new System.Drawing.Size(72, 23);
			this.WriteButton.TabIndex = 13;
			this.WriteButton.Text = "&Write";
			this.WriteButton.Click += new System.EventHandler(this.WriteButton_Click);
			// 
			// HexDumpText
			// 
			this.HexDumpText.Font = new System.Drawing.Font("Courier New", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.HexDumpText.Location = new System.Drawing.Point(8, 96);
			this.HexDumpText.Multiline = true;
			this.HexDumpText.Name = "HexDumpText";
			this.HexDumpText.ReadOnly = true;
			this.HexDumpText.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.HexDumpText.Size = new System.Drawing.Size(304, 120);
			this.HexDumpText.TabIndex = 14;
			this.HexDumpText.Text = "";
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(322, 331);
			this.Controls.Add(this.HexDumpText);
			this.Controls.Add(this.WriteButton);
			this.Controls.Add(this.StatusText);
			this.Controls.Add(this.BaudRateCombo);
			this.Controls.Add(this.PortCombo);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.SearchButton);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.hyperlinkLabel);
			this.Controls.Add(this.WriteProgress);
			this.Controls.Add(this.FilenameText);
			this.Controls.Add(this.label1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "MainForm";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide;
			this.Text = "AYUCR Firmware Updater";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.EnableVisualStyles ();
			Application.Run(new MainForm());
		}

		private void linkLabel1_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			System.Diagnostics.Process.Start(hyperlinkLabel.Text);
		}

		private void comboBox1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
		
		}

		private void Search_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog dlg = new OpenFileDialog ();
			dlg.Title = "Open Firmware File";
			dlg.Filter = "Firmware files (*.hex)|*.hex|All Files (*.*)|*.*";
		
			try 
			{
				if (dlg.ShowDialog () == DialogResult.OK)
				{
					Firmware x = new Firmware ();
					x.Read (dlg.FileName);
			
					// Update the filename box
					FilenameText.Text = dlg.FileName;

					SetFirmware (x);
				}
			}
			catch (Exception ex) 
			{
				MessageBox.Show ("Error reading firmware file: " + ex.Message);
			}

			dlg.Dispose ();
		}

		private void SetStatus (string text)
		{
			StatusText.Text = text;
			StatusText.Refresh ();
		}
				
			
		private void SetFirmware (Firmware f)
		{
			firmware = f;

			if (firmware != null) 
			{
				HexDumpText.Lines = firmware.Dump ().Split ('\n');
				StatusText.Text = firmware.Model + " " + firmware.Version;
				WriteButton.Enabled = true;
			}
			else 
			{
				WriteButton.Enabled = false;
			}
		}

		/// <summary>
		/// Write firmware to controller
		/// </summary>
		private void WriteButton_Click(object sender, System.EventArgs e)
		{
			if (MessageBox.Show (this, "Ensure controller is powered up and in standby mode (blinking light)", 
				"Controller Check",
				MessageBoxButtons.OKCancel) == DialogResult.OK) 
			{
				using (AYUCR ayucr = new AYUCR ())
				{
					WriteProgress.Value = WriteProgress.Minimum;
					WriteProgress.Maximum = (AYUCR.MAXADDR + 1) + AYUCR.MAXUSER + 2;

					try 
					{
						SetStatus ("Connecting...");
						ayucr.Connect (PortCombo.SelectedIndex + 1);
						WriteProgress.PerformStep ();

						SetStatus ("Reading existing firmware...");
						Firmware existing = ayucr.Read (WriteProgress);

						SetStatus ("Validating...");
						if (!firmware.Compare (existing, 0, 0) || !firmware.Compare (existing, AYUCR.MINBOOT, AYUCR.MAXBOOT))
						{
							if (MessageBox.Show (this, 
								"The reserved bootloader portions of the new and existing program images\n" +
								"are different.  Attempting to load this image using the bootloader may\n" +
								"result in damage to the firmware and may require reflashing the chip\n",
								"Firmware mismatch",
								MessageBoxButtons.OKCancel,
								MessageBoxIcon.Warning) != DialogResult.OK)
							{
								return;
							}
						}
						WriteProgress.PerformStep ();

						SetStatus ("Writing new firmware...");
						ayucr.Write (firmware, WriteProgress);

						SetStatus ("Done!");
					}
					catch (Exception ex) 
					{
						SetStatus ("");
						MessageBox.Show ("Error reading firmware file: " + ex.Message);
					}
					finally 
					{
						WriteProgress.Value = WriteProgress.Minimum;
					}

				}
			}
		}
	}
}
